/**************************************************************************
Arxeio Ylopoihshs	: CDCpointer.c
Syggrafeas			: 
Skopos				: Ylopihsh ATD OuraPlus vs 
                      Dipla Syndedemenh Kyklikh Lista me deiktes
Ana8ewrhsh			: Lougiakis Christos
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "OuraPlus.h"

typedef struct typos_komvou *typos_deikti;

typedef struct typos_komvou{
	TStoixeiouOuraPlus dedomena;	/*ta dedomena*/
	typos_deikti    epomenos; 	    /*deikths ston epomeno komvo*/
	typos_deikti    proigoumenos; 	/*deikths ston prohgoymeno komvo*/
} typos_komvou;	   /*o typos toy kombou ths ouraP*/


typedef struct GeneralNode{
        typos_deikti Head,   /* h arxh ths ouraPlus (NULL if list empty) */
                     Last,   /* to telos ths ouraPluss (NULL if list empty) */
                     Current;/* o trexon komvos ths ouraPlus (NULL if list empty) */
        int ListSize;
}GeneralNode;

/*dhlwseis synarthsewn*/

/*dhmioyrgia kai katastrofh ouraPs*/
void OuraPlus_dimiourgia(TOuraPlus * const ouraP) /* initializes Current as NULL  ++++ */
{
 *ouraP=malloc(sizeof(GeneralNode));    /*desmeusi kefalis listas*/
 if(ouraP==NULL)
    printf("Error cannot allocate memory\n");
 (*ouraP)->Head=NULL;   /*arxikopoiisi deikton kefalis se NULL*/
 (*ouraP)->Last=NULL;
 (*ouraP)->Current=NULL;
 (*ouraP)->ListSize=0;  /*arxikopoiisi mikous listas*/
}

void OuraPlus_katastrofi(TOuraPlus * const ouraP)
{
 while (OuraPlus_exagogiArxh(*ouraP)!=0);   /*oso i oura den einai keni exagei to proto stoixeio*/
 free(*ouraP);  /*eleutherosi tis kefalis*/
 *ouraP=NULL;
}

/*prakseis elegxoy*/
int	OuraPlus_keni(const TOuraPlus ouraP)
{
 return((ouraP->Head==NULL)&&(ouraP->Last==NULL)&&(ouraP->Current==NULL)&&(ouraP->ListSize==0));
}

int OuraPlus_megethos(const TOuraPlus ouraP)
{
 return (ouraP->ListSize);
}

/*prakseis prosbashs-allazei to Current*/
int OuraPlus_periexomenoTrexon(const TOuraPlus ouraP, TStoixeiouOuraPlus * const value) /* error if Current invalid */
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	TSOuraPlus_setValue( value, ouraP->Current->dedomena);  /*pernaei sto value ta dedomena tou current*/
	return 1;
 }
}

int OuraPlus_allagiTrexon(const TOuraPlus ouraP, TStoixeiouOuraPlus stoixeio) /* error if Current invalid */
{
 if (ouraP->Current==NULL)
    return 0;
 else{
	TSOuraPlus_setValue(&ouraP->Current->dedomena,stoixeio);    /*pernaei sta dedomena tou current to stoixeio*/
	return 1;
 }
}

/*prakseis eisagwgh-diagrafh Current as prodeiktis */
int OuraPlus_eisagogiTelos(const TOuraPlus ouraP, TStoixeiouOuraPlus stoixeio) /* sto telos */
{
 if (OuraPlus_keni(ouraP)){ /*an lista keni*/
    ouraP->Head=malloc(sizeof(typos_komvou));   /*desmeuei ena komvo kai arxikopoei tous deiktes na deixnoun se auton*/
    if(ouraP->Head==NULL){
        printf("Cannot allocate memory\n");
        return 0;
	}
    ouraP->Last=ouraP->Head;
    ouraP->Current=ouraP->Head;
    ouraP->ListSize++;  /*auxanei to mikos tis listas kata ena*/
    TSOuraPlus_setValue(&ouraP->Head->dedomena,stoixeio);   /*pernaei ta dedomena ston proto komvo*/
    (ouraP->Head->epomenos)=ouraP->Head;    /*arxikopoiei ton deikti epomenos na deixnei ston eauto tou*/
    (ouraP->Head->proigoumenos)=ouraP->Head;/*arxikopoiei ton deikti proigoumenos na deixnei ston eauto tou*/
 }
 else{  /*an i lista den einai keni*/
    ouraP->Last->epomenos=malloc(sizeof(typos_komvou)); /*desmeuei ton kainourio teleutaio komvo*/
    if(ouraP->Last->epomenos==NULL){
        printf("Cannot allocate memory\n");
        return 0;
	}
	ouraP->Last->epomenos->proigoumenos=ouraP->Last;    /*arxikopoiei ton deikti proigoumenos na deixnei ston palio Last*/
	ouraP->Last=ouraP->Last->epomenos;  /*allazei ton deikti Last na deixnei se auton*/
	ouraP->Head->proigoumenos=ouraP->Last;  /*allazei ton deikti proigoumenos tou protou komvou na deixnei se auton*/
	ouraP->Last->epomenos=ouraP->Head;  /*arxikopoiei ton deikti epomenos na deixnei ston proto komvo*/
	ouraP->Current=ouraP->Last;     /*allazei ton deikti Current na deixnei se auton*/
	TSOuraPlus_setValue(&ouraP->Last->dedomena,stoixeio);   /*pernaei ta dedomena ston neo komvo*/
	ouraP->ListSize++;  /*auxanei to mikos tis listas kata ena*/
 }
 return 1;
}

int OuraPlus_exagogiArxh(const TOuraPlus ouraP)/*  sthn arxh  */
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	if (OuraPlus_megethos(ouraP)!=1){   /*an i lista exei perissoterous apo ena komvo*/
		ouraP->Head=ouraP->Head->epomenos;  /*allazei to deikti Head na deixnei ston epomeno*/
		ouraP->Current=ouraP->Head;     /*allazei ton deikti Current na deixnei se auton*/
		free(ouraP->Head->proigoumenos);    /*eleutheronei ton palio proto komvo*/
		ouraP->Head->proigoumenos=ouraP->Last;  /*allazei ton deikti proigoumenos tou protou komvou na deixnei ston Last*/
		ouraP->Last->epomenos=ouraP->Head;  /*allazei ton deikti epomenos tou Last na deixnei ston proto*/
		ouraP->ListSize--;  /*meionei to mikos tis listas kata ena*/
	}
	else{   /*an i lista exei mono ena komvo*/
		free(ouraP->Head);  /*eleutheronei ton komvo*/
		ouraP->Head=NULL;   /*allazei tous deiktes kefalis se NULL*/
		ouraP->Last=NULL;
		ouraP->Current=NULL;
		ouraP->ListSize=0;  /*allagi mikous listas se miden*/
	}
	return 1;
 }
}

int OuraPlus_diagrafiTrexon(const TOuraPlus ouraP) /* diagrafei *trexonta* komvo apo apoydhpote */
{
 typos_deikti temp;
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
    if (ouraP->Current==ouraP->Head)    /*an o komvos pou theloume na afairesoume einai o protos*/
       	return OuraPlus_exagogiArxh(ouraP); /*kalei tin synartisi exagogis protou stoixeiou*/
	if (OuraPlus_megethos(ouraP)!=1){   /*an i lista exei perissoterous apo ena komvo*/
		if (ouraP->Current==ouraP->Last){   /*an o komvos pou theloume na afairesoume einai o teleutaios*/
            ouraP->Last=ouraP->Last->proigoumenos;  /*allazei ton Last na deixnei sto proigoumeno tou Last*/
			ouraP->Current=ouraP->Head; /*allazei ton Current na deinei stin arxi*/
			free(ouraP->Last->epomenos);    /*eleutheronei ton komvo*/
			ouraP->Last->epomenos=ouraP->Head;  /*allazei ton deikti epomenos tou Last na deixnei ston proto*/
			ouraP->Head->proigoumenos=ouraP->Last;  /*allazei ton deikti proigoumenos tou protou komvou na deixnei ston Last*/
			ouraP->ListSize--;  /*meionei to mikos tis listas kata ena*/
		}
		else{
			temp=ouraP->Current;    /*apothikeuei se enan prosorino deikti ton komvo pou theloume na diagrapsoume*/
   			ouraP->Current=ouraP->Current->epomenos;    /*allazei ton Current na deixnei ston epomeno*/
			ouraP->Current->proigoumenos=temp->proigoumenos;    /*allazei ton deikti proigoumenos tou neou Current na deixnei */
			                                                    /* ston proigoumeno tou paliou Current*/
			ouraP->Current->proigoumenos->epomenos=ouraP->Current;/*allazei ton deikti epomenos tou proigoumenou tou Current na deixnei */
			                                                        /*ston neou Current*/
			free(temp); /*eleutheronei ton komvo pou thelame*/
			ouraP->ListSize--;  /*meionei to mikos tis listas kata ena*/
		}
	}
	else{   /*an i lista exei mono ena komvo*/
		free(ouraP->Head);  /*eleutheronei ton komvo*/
		ouraP->Head=NULL;   /*allazei tous deiktes kefalis se NULL*/
		ouraP->Last=NULL;
		ouraP->Current=NULL;
		ouraP->ListSize=0;  /*allagi mikous listas se miden*/
	}
	return 1;
 }
}

/* Epilogh Kombou Current */

int OuraPlus_epomenos(const TOuraPlus ouraP) /* if noNext no move + error */
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	ouraP->Current=ouraP->Current->epomenos;
	return 1;
 }
}

int OuraPlus_proigoymenos(const TOuraPlus ouraP) /* if noPrev no move + error*/
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	ouraP->Current=ouraP->Current->proigoumenos;
	return 1;
 }
}

int OuraPlus_prwtos(const TOuraPlus ouraP) /* to First - if empty to Head + error */
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	ouraP->Current=ouraP->Head;
	return 1;
 }
}

int OuraPlus_teleytaios(const TOuraPlus ouraP) /* to Last - if empty to Last + null*/
{
 if (OuraPlus_keni(ouraP))
    return 0;
 else{
	ouraP->Current=ouraP->Last;
	return 1;
 }
}

/*prakseis anazhthshs*/

int OuraPlus_anazitisi(const TOuraPlus ouraP, TStoixeiouOuraPlus stoixeio, int (*iso)(TStoixeiouOuraPlus , TStoixeiouOuraPlus))
{
 int i, plithos;
 TStoixeiouOuraPlus value;
 i=1;
 plithos=OuraPlus_megethos(ouraP);
 OuraPlus_teleytaios(ouraP);    /*paei ston teleutaio komvo*/
 OuraPlus_periexomenoTrexon( ouraP, &value);    /*pairnei to periexomeno tou*/
 while((*TSOuraPlus_iso)(stoixeio, value)<1 && i<=plithos){ /*oso to stoixeio pou psaxnoume mikrotero tou Current stoixeiou kai */
                                                            /*den exoume prospelasei oli ti lista*/
    OuraPlus_proigoymenos(ouraP);   /*sinexizei ston proigoumeno*/
    OuraPlus_periexomenoTrexon( ouraP, &value); /*pairnei to periexomeno tou*/
    i++;    /*auxanei to plithos ton stoixeion pou exoun elegxthei*/
 }
 if((*TSOuraPlus_iso)(stoixeio, value)==1)  /*an to stoixeio pou psaxnoume vrethike epstrefei 0*/
    return 0;
 else
	return 1;
}
